%bcond_with     xvnc
%define vnc     vnc
%define gcj_support 1

Name:           tightvnc
Version:        1.3.10
Release:        %mkrel 2
Summary:        Remote graphical access
Group:          Networking/Remote access
License:        GPL
URL:            http://www.tightvnc.org/        
Source0:        http://dl.sourceforge.net/vnc-tight/tightvnc-%{version}_unixsrc.tar.bz2
Source1:        http://www.uk.research.att.com/vnc/dist/vnc-latest_doc.tar.bz2
Source2:        %{name}-icons.tar.bz2
Source3:        vncserverinit
Source5:        http://downloads.sourceforge.net/vnc-tight/tightvnc-%{version}_javasrc.tar.gz
Patch0:         vnc-xclients.patch
Patch1:         tightvnc-1.2.6-config-x86_64.patch
Patch2:         vncserver-vncpasswd-1.2.6.patch
Patch3:         vncserver-halfbaked.patch
Patch4:         vncviewer-fix-crash-when-lose-focus.patch
Patch6:         tightvnc-1.3.10-includes.patch
Patch7:         tightvnc-xf4vnc-no-xkb.patch
Patch8:         vnc_unixsrc-CVE-2007-1003.patch
Patch9:         vnc_unixsrc-CVE-2007-1351-1352.patch
Patch10:	tightvnc-1.3.9-format-security.patch
Obsoletes:      vnc < %{version}-%{release}
Provides:       vnc = %{version}-%{release}
Obsoletes:	nxviewer < 3.2.0
Provides:	nxviewer
BuildRequires:  gccmakedep
BuildRequires:  imake
BuildRequires:  libjpeg-devel
BuildRequires:  libxpm-devel
BuildRequires:  libxt-devel
BuildRequires:  libxmu-devel
BuildRequires:  libxaw-devel
Buildrequires:	libxp-devel
BuildRequires:  libz-devel
BuildRequires:  rman
BuildRequires:  tcp_wrappers-devel
BuildRequires:  X11-devel
BuildRequires:  xorg-x11
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
VNC allows you to access to a remote graphical display through the network.

The enhanced version of VNC, called TightVNC (grown from the  VNC  Tight
Encoder  project), is  optimized  to  work  over  slow   network
connections such as low-speed modem links. While  original  VNC  may  be
very slow when your connection is not fast enough, with TightVNC you can
work  remotely  almost  in  real  time  in  most  environments.  Besides
bandwidth optimizations, TightVNC also includes many other improvements,
optimizations and  bugfixes  over  VNC.  Note  that  TightVNC  is  free,
cross-platform and compatible with the standard VNC.

%package server
Summary:        A VNC server
Group:          System/Servers
Requires(post): rpm-helper
Requires(preun): rpm-helper
Obsoletes:      vnc-server < %{version}-%{release}
Provides:       vnc-server = %{version}-%{release}
%if %without xvnc
Requires:       x11-server-xvnc
%else
Conflicts:      x11-server-xvnc
%endif

%description server
The VNC system allows you to access the same desktop from a wide variety
of platforms. This package is a VNC server, allowing  others  to  access
the desktop on your machine.

%package java
Summary:        A VNC server
Group:          Development/Java
Obsoletes:      vnc-java < %{version}-%{release}
Provides:       vnc-java = %{version}-%{release}
BuildRequires:  java-rpmbuild
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
BuildRequires:  java-devel
%endif

%description java
The VNC system allows you to access the same desktop from a wide variety
of platforms. This package is a VNC server, allowing  others  to  access
the desktop on your machine.

%package doc
Summary:        Complete documentation for VNC
Group:          Networking/Remote access
Obsoletes:      vnc-doc < %{version}-%{release}
Provides:       vnc-doc = %{version}-%{release}

%description doc
This package contains HTML  documentation  about  VNC  (Virtual  Network
Computing) programs. Install the vnc-doc package if you  want  extensive
online documentation about VNC.

%prep
%setup -q -n vnc_unixsrc
%setup -q -T -D -a1 -n vnc_unixsrc
%setup -q -T -D -a2 -n vnc_unixsrc
%setup -q -T -D -a5 -n vnc_unixsrc
%{__perl} -pi -e 's/ \-O//' vnc_javasrc/Makefile
%patch0 -p1
%patch1 -p1
%patch2 -p1 
%patch3 -p1
%patch4 -p1
%patch6 -p1 -b .includes

%if %without xvnc
%patch7 -p1
%endif
%patch8 -p1
%patch9 -p1
%patch10 -p1

# nuke references to /usr/local
find . -name Imakefile | \
  xargs perl -pi -e "s,(-[IL]/usr/local/(include|lib)),,g"

# remove cvs-files from distribution.
find . -name "*,v" -exec rm -f {} \;
perl -pi -e "s|/usr/local/vnc/classes|%{_datadir}/vnc/classes|" vncserver
perl -pi -e 's|^\$fontPath =.*|\$fontPath = "catalogue:%{_sysconfdir}/X11/fontpath.d/";|' vncserver

%build
%{serverbuild}
xmkmf
make CONFIGDIR=%{_datadir}/X11/config Makefiles
make CONFIGDIR=%{_datadir}/X11/config includes
make CONFIGDIR=%{_datadir}/X11/config depend
make CDEBUGFLAGS="$RPM_OPT_FLAGS" CONFIGDIR=%{_datadir}/X11/config World
%if %with xvnc
cd Xvnc
./configure
make EXTRA_LIBRARIES="-lwrap -lnss_nis" CDEBUGFLAGS="$RPM_OPT_FLAGS" World \
        EXTRA_DEFINES="-DUSE_LIBWRAP=1"
cd ..
%endif

cd vnc_javasrc
%{__make} ARCHIVE=vncviewer-%{version}.jar CP=%{__cp} JC=%{javac} JCFLAGS="-g" JAR=%{jar} INSTALL_DIR= clean all

%install
rm -rf %{buildroot}

install -d -m 755 %{buildroot}%{_bindir}
install -m 755 vncviewer/vncviewer %{buildroot}%{_bindir}/vncviewer
install -m 755 vncpasswd/vncpasswd %{buildroot}%{_bindir}/vncpasswd
install -m 755 vncconnect/vncconnect %{buildroot}%{_bindir}/vncconnect
install -m 755 vncserver %{buildroot}%{_bindir}/vncserver
%if %with xvnc
install -m 755 Xvnc/programs/Xserver/Xvnc %{buildroot}%{_bindir}/Xvnc
%endif

install -d -m 755 %{buildroot}%{_mandir}/man1
install -m 644 vncviewer/vncviewer.man %{buildroot}%{_mandir}/man1/vncviewer.1
install -m 644 vncpasswd/vncpasswd.man %{buildroot}%{_mandir}/man1/vncpasswd.1
install -m 644 vncconnect/vncconnect.man %{buildroot}%{_mandir}/man1/vncconnect.1
install -m 644 vncserver.man %{buildroot}%{_mandir}/man1/vncserver.1
install -m 644 Xvnc/programs/Xserver/Xvnc.man %{buildroot}%{_mandir}/man1/Xvnc.1
# 1 extra man page; Xserver.man; This is the  original Xserver manpage
# and should only be installed if no X is on the system. I choose not to
# include it.

# handle documentation manually
install -d -m 755 %{buildroot}%{_docdir}/%{name}
install -m 644 ChangeLog README WhatsNew %{buildroot}%{_docdir}/%{name}
cp -a vnc_docs/* %{buildroot}%{_docdir}/%{name}

# icons
install -D -m 644 %{name}48.png %{buildroot}%{_liconsdir}/%{name}.png
install -D -m 644 %{name}32.png %{buildroot}%{_iconsdir}/%{name}.png
install -D -m 644 %{name}16.png %{buildroot}%{_miconsdir}/%{name}.png

# Menu entry
mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/mandriva-%{name}.desktop << EOF
[Desktop Entry]
Name=Tightvnc
Comment=Remote graphical access
Exec=%{_bindir}/vncviewer
Icon=tightvnc
Terminal=true
Type=Application
Categories=Network;RemoteAccess;Dialup;
EOF

install -d -m 0755 %{buildroot}%{_sysconfdir}/sysconfig
cat > %{buildroot}/%{_sysconfdir}/sysconfig/%{vnc}servers << EOF
# The VNCSERVERS variable is a list of display:user pairs.
#
# Uncomment the line below to start a VNC server on  display  :1  as  my
# 'myusername' (adjust this to your own). You will also need  to  set  a
# VNC password;  run 'man vncpasswd' to see how to do that.  Options for
# a vnc server can be appended to the list entry, using : as separator.
#   example:  2:myusername:-geometry:640x480
#
# DO NOT RUN THIS SERVICE if your local area network is untrusted. For a
# secure way of using VNC, see <URL:http://www.tightvnc.org>.

# VNCSERVERS="1:myusername"
EOF

install -m 0755 %{SOURCE3} -D %{buildroot}/%{_initrddir}/%{vnc}server

%{__mkdir_p} %{buildroot}%{_javadir}
cd vnc_javasrc
%{__make} ARCHIVE=vncviewer-%{version}.jar CP=%{__cp} JC=%{javac} JCFLAGS="-g" JAR=%{jar} INSTALL_DIR=%{buildroot}%{_javadir} install
(cd %{buildroot}%{_javadir} && %{__ln_s} vncviewer-%{version}.jar VncViewer-%{version}.jar)
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do %{__ln_s} ${jar} ${jar/-%{version}/}; done)
%{__rm} %{buildroot}%{_javadir}/*.class

%{__mkdir_p} %{buildroot}%{_datadir}/vnc/classes
%{__cp} -a index.vnc %{buildroot}%{_datadir}/vnc/classes
(cd %{buildroot}%{_datadir}/vnc/classes && %{__ln_s} VncViewer.jar VncViewer.jar)

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf %{buildroot}

%post
%if %mdkversion < 200900
%{update_menus}
%endif
%{make_session}

%postun
%if %mdkversion < 200900
%{clean_menus}
%endif
%{make_session}

%post server
%_post_service vncserver

%preun server
%_preun_service vncserver

%if %{gcj_support}
%post java
%{update_gcjdb}

%postun java
%{clean_gcjdb}
%endif

%files
%defattr(-,root,root)
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/README
%{_docdir}/%{name}/WhatsNew
%{_docdir}/%{name}/ChangeLog
%{_bindir}/vncviewer
%{_mandir}/man1/vncviewer.1*
%{_datadir}/applications/mandriva-%{name}.desktop
%{_liconsdir}/%{name}.png
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png

%files doc
%defattr(0644,root,root,0755)
%{_docdir}/%{name}/*
%exclude %{_docdir}/%{name}/README
%exclude %{_docdir}/%{name}/WhatsNew
%exclude %{_docdir}/%{name}/ChangeLog

%files server
%defattr(-,root,root)
%doc vnc_javasrc/{LICENCE.TXT,README,WhatsNew,index.html}
%if %with xvnc
%{_bindir}/Xvnc
%endif
%{_bindir}/vncserver
%{_bindir}/vncpasswd
%{_bindir}/vncconnect
%{_initrddir}/%{vnc}server
%{_mandir}/man1/Xvnc.1*
%{_mandir}/man1/vncserver.1*
%{_mandir}/man1/vncconnect.1*
%{_mandir}/man1/vncpasswd.1*
%config(noreplace) %{_sysconfdir}/sysconfig/%{vnc}servers

%files java
%defattr(0644,root,root,0755)
%{_javadir}/*
%{_datadir}/vnc
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*
%endif


%changelog
* Sat Aug 15 2009 Oden Eriksson <oeriksson@mandriva.com> 1.3.10-2mdv2010.0
+ Revision: 416533
- rebuilt against libjpeg v7

* Sun May 03 2009 Funda Wang <fundawang@mandriva.org> 1.3.10-1mdv2010.0
+ Revision: 370989
- New version 1.3.10

* Sat Mar 28 2009 Funda Wang <fundawang@mandriva.org> 1.3.9-19mdv2009.1
+ Revision: 361912
- BR libxp

* Tue Feb 03 2009 Guillaume Rousse <guillomovitch@mandriva.org> 1.3.9-18mdv2009.1
+ Revision: 337183
- keep bash completion in its own package

* Thu Jan 29 2009 Ander Conselvan de Oliveira <ander@mandriva.com> 1.3.9-17mdv2009.1
+ Revision: 335249
- Do not pass -co (colorPath) option to Xvnc. It was removed on X.org 1.6.
- Rediff patches to apply with fuzz=0
- Fix for -Werror=format-security

* Fri Sep 05 2008 Adam Williamson <awilliamson@mandriva.org> 1.3.9-16mdv2009.0
+ Revision: 280997
- obsolete nxviewer (a fork of vncviewer for nx which was dropped with nx
  3.2.0)

* Tue Aug 05 2008 Nicolas Lécureuil <neoclust@mandriva.org> 1.3.9-15mdv2009.0
+ Revision: 263757
- Show back on kde menu

* Mon Jul 07 2008 Nicolas Lécureuil <neoclust@mandriva.org> 1.3.9-14mdv2009.0
+ Revision: 232625
- Do not show on KDE menu ( KDE menu cleaning task )

* Wed Jun 18 2008 Thierry Vignaud <tvignaud@mandriva.com> 1.3.9-13mdv2009.0
+ Revision: 225716
- rebuild
- kill re-definition of %%buildroot on Pixel's request

  + Pixel <pixel@mandriva.com>
    - rpm filetriggers deprecates update_menus/update_scrollkeeper/update_mime_database/update_icon_cache/update_desktop_database/post_install_gconf_schemas

  + Anssi Hannula <anssi@mandriva.org>
    - fix Xvnc build (remove Xvnc buildfix patch5)
    - server conflicts with x11-server-xvnc when building with --with xvnc

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Sun Dec 16 2007 Anssi Hannula <anssi@mandriva.org> 1.3.9-12mdv2008.1
+ Revision: 121030
- buildrequire java-rpmbuild, i.e. build with icedtea on x86(_64)

* Sat Nov 24 2007 David Walluck <walluck@mandriva.org> 1.3.9-11mdv2008.1
+ Revision: 111733
- copy/link java files to correct location

* Fri Nov 23 2007 David Walluck <walluck@mandriva.org> 1.3.9-10mdv2008.1
+ Revision: 111689
- enable and fix colorPath

* Sun Nov 18 2007 David Walluck <walluck@mandriva.org> 1.3.9-9mdv2008.1
+ Revision: 109788
- fix font path

* Mon Oct 15 2007 David Walluck <walluck@mandriva.org> 1.3.9-8mdv2008.1
+ Revision: 98727
- fix font path

* Sat Sep 15 2007 Anssi Hannula <anssi@mandriva.org> 1.3.9-7mdv2008.0
+ Revision: 87208
- rebuild to filter out autorequires of GCJ AOT objects
- remove unnecessary Requires(post) on java-gcj-compat

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill desktop-file-validate's 'warning: key "Encoding" in group "Desktop Entry" is deprecated'

* Sat Aug 18 2007 David Walluck <walluck@mandriva.org> 1.3.9-6mdv2008.0
+ Revision: 65438
- fix menu comment
- add some releases to the provides/obsoletes

* Thu Jul 05 2007 David Walluck <walluck@mandriva.org> 1.3.9-5mdv2008.0
+ Revision: 48408
- BuildRequires: jpackage-util
- add versioned obsoletes/provides
- build java classes
- mark file in %%{_sysconfdir} as %%config(noreplace)
- fix executable perms on files in doc package

* Wed Jul 04 2007 Andreas Hasenack <andreas@mandriva.com> 1.3.9-4mdv2008.0
+ Revision: 48262
- use new serverbuild macro (-fstack-protector-all)

* Wed Jun 27 2007 Guillaume Rousse <guillomovitch@mandriva.org> 1.3.9-3mdv2008.0
+ Revision: 44904
- handle doc manually, as %%doc macro sux
- don't ship java binaries
- clean up installation and file list
- drop old debian menu
- bash completion
- drop mandriva-specific category in menu

* Tue May 08 2007 David Walluck <walluck@mandriva.org> 1.3.9-2mdv2008.0
+ Revision: 25024
- use cp -a instead of cp -R
- one BuildRequires per line
- remove bogus Requires(pre)
- remove extra mkdir for menudir
- LSB initscript
- renumber patches
-remove ExclusiveArch
- no need to force bzip2 manpages
- use with option for xvnc
- 1.3.9

* Sat May 05 2007 Lenny Cartier <lenny@mandriva.org> 1.2.9-16mdv2008.0
+ Revision: 22620
- Apply CVE patches 2007-1003 and 2007-1351-1352 (Bug #29820)


* Wed Oct 18 2006 Christiaan Welvaart <cjw@daneel.dyndns.org>
+ 2006-10-18 19:42:07 (71005)
- allow arbitrary vncserer options in sysconfig file
- always pass -kb to xf4vnc Xvnc (fixes bug #21031)

* Fri Oct 13 2006 Christiaan Welvaart <cjw@daneel.dyndns.org>
+ 2006-10-13 11:58:09 (64558)
- rebuild to get x86-64 packages

* Thu Oct 12 2006 Christiaan Welvaart <cjw@daneel.dyndns.org>
+ 2006-10-12 19:26:34 (64469)
- fix build on x86-64

* Thu Oct 12 2006 Christiaan Welvaart <cjw@daneel.dyndns.org>
+ 2006-10-12 09:56:19 (63796)
- use x11-server-xvnc
- add BuildRequires: libxt-devel libxmu-devel libxaw-devel

* Thu Oct 12 2006 Christiaan Welvaart <cjw@daneel.dyndns.org>
+ 2006-10-12 09:43:57 (63790)
Import tightvnc

* Wed Sep 06 2006 Lenny Cartier <lenny@mandriva.com> 1.2.9-13mdv2007.0
- enable build of Xvnc

* Sat Aug 26 2006 Emmanuel Andry <eandry@mandriva.org> 1.2.9-12mdv2007.0
- fix x11 path (bug #23248)
- xdg menu

* Tue Jun 20 2006 Lenny Cartier <lenny@mandriva.com> 1.2.9-11mdv2007.0
- try to fix Bug #15988 with patch from Tim Edwards
- fix group

* Sun Jun 11 2006 Jerome Soyer <saispo@mandriva.org> 1.2.9-1mdv2007.0
- Fix changelog

* Sun Jun 11 2006 Jerome Soyer <saispo@mandriva.org> 1.2.9-9mdk
- Shlomi Fish <shlomif@iglu.org.il> 1.2.9-9mdk
- Ported to Mandriva 2007 and its xorg-x11 dependencies.

* Tue Jan 24 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.2.9-8mdk
- build on ppc64
- more includes & 64-bit fixes
- use Xvnc server from X.org, i.e. drop ancient one based on XFree86 3.3

* Sun Jan 01 2006 Mandriva Linux Team <http://www.mandrivaexpert.com/> 1.2.9-7mdk
- Rebuild

* Mon May 30 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.2.9-6mdk
- includes & 64-bit fixes

* Wed Dec 22 2004 Per Ãyvind Karlsen <peroyvind@linux-mandrake.com> 1.2.9-5mdk
- fix buildrequires
- cosmetics

* Fri Sep 03 2004 Daouda LO <daouda@mandrakesoft.com> 1.2.9-4mdk
- The requirement for the fd_set structure to have a member fds_bits 
  has been removed as per The Open Group Base Resolution
- do not redefine malloc (use stdlib one) -> keep synced with Xorg.
- fix menu entry (fcrozat)

* Sat Apr 10 2004 Michael Scherer <misc@mandrake.org> 1.2.9-3mdk 
- [DIRM]
- A better description

* Tue Mar 16 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 1.2.9-2mdk
- Add patch5: fix crash into kwin and co, patch from Lubos Lunak <l.lunak@suse.cz>

* Sat Dec 13 2003 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.2.9-1mdk
- 1.2.9

